/* --------------------------------------------------------
 *  4-bit ALU(Arithmetic Logic Unit)
 *	(alu4.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module alu4(S, A, B, F);
    input  [2:0] S;	// operation selection
    input  [3:0] A, B;	// input data
    output [3:0] F;	// result

    function [4:0] operation;
        input [2:0] s;
        input [3:0] a, b;
        
        begin
            case(s)
              3'b000 : operation = 4'b0000;
              3'b001 : operation = b - a;
              3'b010 : operation = a - b;
              3'b011 : operation = a + b;
              3'b100 : operation = a ^ b;
              3'b101 : operation = a | b;
              3'b110 : operation = a & b;
              3'b111 : operation = 4'b1111;
              default: operation = 4'bXXXX;
            endcase
        end
    endfunction
    
    assign F = operation(S, A, B);

endmodule