/* --  V~[V  ------------------------------
 *  ALU4 
 *	(alu4sim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */
 
module alu4_sim();
    reg  [2:0] s;
    reg  [3:0] a, b;
    wire [3:0] rslt;

  // ݌vΏۂ̃CX^VF[V
    alu4 alu4(s, a, b, rslt);

  // ϑM̎w
    initial begin
        $display("                      s   a    b       rslt") ;
        $display("                TIME: 210 3210 3210 -> 3210");
        $display("--------------------:----+----+------------");
        $monitor("%t: %b %b %b -> %b",
                  $stime, s, a, b, rslt);
    end

  // eXgM
    initial begin
      // clear
        $display("clear");
        s = 3'b000;
        a = 4'b0000;
        b = 4'b0000;
      #10
      // b - a
        $display("b - a");
        s = 3'b001;
        a = 4'b0000;
        b = 4'b1000;
      #10
        a = 4'b0001;
        b = 4'b1000;
      #10
        a = 4'b0001;
        b = 4'b0000;
      #10
        a = 4'b1000;
        b = 4'b0000;
      #10
        a = 4'b1111;
        b = 4'b0000;
      #10
        a = 4'b1111;
        b = 4'b1111;
      #10
      // a - b
        $display("a - b");
        s = 3'b010;
        a = 4'b0000;
        b = 4'b1000;
      #10
        a = 4'b0001;
        b = 4'b1000;
      #10
        a = 4'b0001;
        b = 4'b0000;
      #10
        a = 4'b1000;
        b = 4'b0000;
      #10
        a = 4'b1111;
        b = 4'b0000;
      #10
        a = 4'b1111;
        b = 4'b1111;
      #10
      // a + b
        $display("a + b");
        s = 3'b011;
        a = 4'b0000;
        b = 4'b1000;
      #10
        a = 4'b0001;
        b = 4'b1000;
      #10
        a = 4'b0001;
        b = 4'b0000;
      #10
        a = 4'b1000;
        b = 4'b0000;
      #10
        a = 4'b1111;
        b = 4'b0000;
      #10
        a = 4'b1111;
        b = 4'b1111;
      #10
      // a ^ b
        $display("a ^ b");
        s = 3'b100;
        a = 4'b1010;
        b = 4'b1100;
      #10
      // a | b
        $display("a | b");
        s = 3'b101;
        a = 4'b1010;
        b = 4'b1100;
      #10
      // a & b
        $display("a & b");
        s = 3'b110;
        a = 4'b1010;
        b = 4'b1100;
      #10
      // preset
        $display("preset");
        s = 3'b111;
        a = 4'b1010;
        b = 4'b1100;
      #10
      $finish;			// V~[VI
    end
endmodule
