/* --------------------------------------------------------
 *  interval counter
 *	(intvl_counter.v)	designed by Shinya KIMURA
 * -------------------------------------------------------- */

`include "my_const.v"

module intvl_counter(clock, reset_N, start, intval, timeout);
    input        clock;
    input        reset_N;
    input        start;
    input  [7:0] intval;
    output       timeout;

    reg [7:0] counter;
    reg       timeout;

    always @(negedge clock or negedge reset_N) begin
        if(!reset_N) begin
            counter <= 0;
	    timeout <= `ON;
	end else if(timeout && start) begin
	    counter <= intval;
	    timeout <= `OFF;
	end else if(!timeout) begin
	    counter <= counter - 1;
	    if(counter==0) begin
	        timeout <= `ON;
	    end
	end
    end

endmodule
