/* --------------------------------------------------------
 *  clock divider (1/2 .. 1/257)
 *
 *    xtal frequency      = X[MHz]
 *         base period    = 1/X[us]
 *    period parameter    = N (2nd signal of port list)
 *    output clock period = (1/X) * (N+2)
 *    duty (nearly 50%)
 *             LOW : HIGH = (N/2 + 1) : (N/2 + 1 + N[0])
 *
 *	(clkdiv.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module clkdiv(xtal, period, divclk);
    input        xtal;		// 1[MHz]
    input  [7:0] period;	// osc peirod [us]
    output       divclk;	// divided clock

    reg [7:0] count;
    reg       divclk;

    always @(posedge xtal) begin
	if(!divclk) begin
            if(count == period[7:1]) begin
                count  <= 0;
                divclk <= 1;
	    end else begin
                count <= count + 1;
	    end
        end else begin
	    if(count == period[7:1]+period[0]) begin
                count  <= 0;
                divclk <= 0;
            end else begin
                count <= count + 1;
            end
	end
    end

endmodule
