/* --------------------------------------------------------
 *  clock divider (1/512 fix)
 *	(clkdiv512.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module clkdiv512(xtal, clock);
    input        xtal;		// 1[MHz]
    output       clock;		// 1/512 [MHz] = 1.953[KHz]
    
    reg [8:0] clkdiv;		// clock divider
    
    always @(posedge xtal) begin
        clkdiv <= clkdiv + 1;
    end

    assign clock = clkdiv[8];	// 1/512 [MHz] = 1.953[KHz]
endmodule
