/* --  V~[V  ------------------------------
 *  title
 *	(file name *sim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */
 
 module IR_tx_rx_sim();
    reg        clk, rst_N;
    reg  [3:0] clkdiv;
    reg  [3:0] id, myid;
    reg  [7:0] tx_data;
    reg        start_N, rd_stb;

    wire       clk16;
    wire       s_out, rd_full;
    wire [7:0] rx_data;
    wire [3:0] err;

  // ݌vΏۂ̃CX^VF[V
    IR_transmitter TX(clk16, rst_N, start_N, id, tx_data, s_out);
    IR_receiver    RX(clk,   rst_N, s_out, myid, rd_stb, rd_full, rx_data, err);

  // ϑM̎w
    initial begin
        $display("                            | ---- T X ---- | ------------- R X ------------- ");
        $display("                            |               |                                 ");
        $display("                      c c r | s TX s      s | r r RX        s r               ");
        $display("                      l l s | t  d t      | | d d  d        t x               ");
        $display("                      o k t | a  a a      o | f s  a  err   a e            RX ");
        $display("                      c 1 | | r  t t   TX u | u t  t IPFO   t n   id     data ") ;
        $display("                TIME: k 6 N | t  a e buff t | l b  a DRRV 210 d 3210 76543210 ");
        $display("--------------------:-------|---------------|---------------------------------");
        $monitor("%t: %b %b %b | %b %h %b %h %b | %b %b %h %b %b %b %b %b",
                  $stime, clk, clk16, rst_N,
                  start_N, tx_data, TX.state, TX.buffer, s_out,
                  rd_full, rd_stb, rx_data, err, RX.state, RX.rx_end, RX.id, RX.data);
    end


  // ^XN
    task wait_posedge_clk;
        input   n;
        integer n;

        begin
            for( n=n; n>0; n=n-1) begin
                @(posedge clk)
                  ;	// empty
            end
        end
    endtask

  // M
    initial begin
        clk     <= 1'b0;
        rst_N   <= 1'b0;
        clkdiv  <= 7'b00000;
        id      <= 4'b1010;
        myid    <= 4'b1010;
        start_N <= 1'b1;
        rd_stb  <= 1'b0;
    end

  // NbNU
    always #100 begin
        clk <= !clk;
    end

    always @(posedge clk) begin
        clkdiv <= clkdiv + 1;
    end

    assign clk16 = clkdiv[3];

  // eXgM
    initial begin
        wait_posedge_clk(100);
        rst_N <= 1'b1;
        wait_posedge_clk(100);
        @(negedge clk16)
        tx_data <= 8'h5A;
        start_N <= 1'b0;
        @(negedge clk16)
        start_N <= 1'b1;

        wait(rd_full);
        wait_posedge_clk(50);
        @(negedge clk)
        rd_stb <= 1'b1;
        @(negedge clk)
        rd_stb <= 1'b0;

        wait_posedge_clk(100);



      $finish;			// V~[VI
    end
endmodule
