/* --  V~[V  ------------------------------
 *  adder4 + bcd 7-seg LED decoder
 *	(add7segsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module add7segsim();
    reg  [3:0] in1, in2;
    wire [3:0] rslt;
    wire       cy;
    wire [6:0] seg;
    wire       sega, segb, segc, segd, sege, segf, segg; 

  // Mu
    assign {sega, segb, segc, segd, sege, segf, segg} = seg;

  // eXgW[̃CX^VF[V
    adder4  adder4 (in1, in2, rslt, cy);
    bcd7seg bcd7seg(rslt, seg);

  // eXgM
    initial begin
      #10
        in1 <= 4'b0000;		// eXg͐Mݒ
        in2 <= 4'b0000;
      #10			// oߐݒ
        chardisp(sega, segb, segc, segd, sege, segf, segg);
        in1 <= 4'b0110;
        in2 <= 4'b0011;
      #10
        chardisp(sega, segb, segc, segd, sege, segf, segg);
        in1 <= 4'b0111;
        in2 <= 4'b1100;
      #10
        chardisp(sega, segb, segc, segd, sege, segf, segg);
        in1 <= 4'b1111;
        in2 <= 4'b1111;
      #10
        chardisp(sega, segb, segc, segd, sege, segf, segg);
      $finish;			// V~[VI
    end

    // 7-seg X^C\
    task chardisp;
        input a, b, c, d, e, f, g;
        begin
            if(a) $write(" --\n"); else $write("\n");
            if(f) $write("|  ");   else $write("   ");
            if(b) $write("|\n");   else $write("\n");
            if(g) $write(" --\n"); else $write("\n");
            if(e) $write("|  ");   else $write("   ");
            if(c) $write("|\n");   else $write("\n");
            if(d) $write(" --\n"); else $write("\n");
            $write("\n");
        end
    endtask
    
endmodule
