/* --  Altera FLEX10K _pgbvW[  ---------
 *  4-bit adder with 7-segment decoder
 *      (add7segtop.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module flextbtop(XTAL, RESET_N, CLKSEL, MANCLK, CHIPSEL_N, 
                 ADRSWR_N, DATAWR_N, DATARD_N, SW,
                 LED, EXTIORD_N, EXTIOWR_N, IOBUFIN_N, IOBUFEN_N,
                 LEDCLK_N, EXTIODATA, PCDATA);

  // C^[tF[XM`
    input         XTAL;      // X'tal OSC
    input         RESET_N;   // reset
    input         CLKSEL;    // clock select
    input         MANCLK;    // manual switch clock
    input         CHIPSEL_N; // FPGA select
    input         ADRSWR_N;  // address port write strobe
    input         DATAWR_N;  // data port write strobe
    input         DATARD_N;  // data port read strobe
    input  [ 7:0] SW;        // switch input
    output [15:0] LED;       // LED output
    output        EXTIORD_N; // external I/O read strobe
    output        EXTIOWR_N; // external I/O write strobe
    output        IOBUFIN_N; // I/O buffer input
    output        IOBUFEN_N; // I/O buffer enable
    output        LEDCLK_N;  // clock LED
    inout  [ 7:0] EXTIODATA; // external I/O data
    inout  [ 7:0] PCDATA;    // host PC data

  // `bvM`
    wire          xtal, reset_N, clksel, manclk, clock;
    wire          chipsel_N, adrswr_N, datawr_N, datard_N;
    wire   [ 7:0] sw;
    wire   [15:0] led;
    
    wire   [ 3:0] rslt;		/* ǉ */
    wire   [ 6:0] seg;		/* ǉ */    
    wire          cy;		/* ǉ */

  // ͐Mڑ
    assign sw        = SW;
    assign xtal      = XTAL;
    assign reset_N   = RESET_N;
    assign clksel    = CLKSEL;
    assign manclk    = MANCLK;
    assign chipsel_N = CHIPSEL_N;
    assign adrswr_N  = ADRSWR_N;
    assign datawr_N  = DATAWR_N;
    assign datard_N  = DATARD_N;

  // o͐MftHgڑ
    assign EXTIORD_N = 1;
    assign EXTIOWR_N = 1;
    assign IOBUFIN_N = 0;
    assign IOBUFEN_N = 0;
    assign LED       = ~led;
    assign led[15:13] = 3'b000;				/* C */

  // oMftHgڑ
    assign EXTIODATA = IOBUFIN_N                 ? sw[7:0] : 8'hZZ;
    assign PCDATA    = (!chipsel_N && !datard_N) ? sw[7:0] : 8'hZZ;

  // NbN͑I@NbNLED\hCo[
    assign clock    = clksel ? xtal : manclk;
    assign LEDCLK_N = !clock;

  //  RAEW[̃CX^VF[V
    adder4 adder4(sw[7:4], sw[3:0], rslt, cy);	
    bcd7seg bcd7seg(rslt, seg);
    assign {led[0], led[1], led[2], led[3],
            led[4], led[5], led[6], led[7]} = {seg, cy};
    assign  led[11:8]                       = rslt;
    assign  led[12]                         = cy;

endmodule
