/*
 *  bcd to 7-seg LED decoder (functionCifo[W)
 *      (hex7seg1.v)    (C)2000 Shinya KIMURA
 */

module bcd7seg(hex, seg);
    input  [3:0] hex;
    output [6:0] seg; // = [a, b, c, d, e, f, g]

    assign seg = bcd7segdec(hex);
    
    function [6:0] bcd7segdec;
        input [3:0] hex;
        begin
            if(hex==0)      bcd7segdec = 7'b1111110;
            else if(hex==1) bcd7segdec = 7'b0110000;
            else if(hex==2) bcd7segdec = 7'b1101101;
            else if(hex==3) bcd7segdec = 7'b1111001;
            else if(hex==4) bcd7segdec = 7'b0110011;
            else if(hex==5) bcd7segdec = 7'b1011011;
            else if(hex==6) bcd7segdec = 7'b1011111;
            else if(hex==7) bcd7segdec = 7'b1110000;
            else if(hex==8) bcd7segdec = 7'b1111111;
            else if(hex==9) bcd7segdec = 7'b1111011;
            else            bcd7segdec = 7'b0110111; // X
        end
    endfunction
endmodule
