/* --------------------------------------------------------
 *  barrel rotater (shift operation version)
 *	(barrel_sft_prm.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module barrel_rotate_prm(l_r, sft, in, rslt);
    parameter N = 4;	    // N = log2(bit-width)
    input             l_r;  // 1=left, 0=right
    input  [   N-1:0] sft;  // shift no.
    input  [2**N-1:0] in;   // input data
    output [2**N-1:0] rslt; // rotated data

    assign rslt = l_r ? (in<<sft | in>>2**N-sft):
                        (in>>sft | in<<2**N-sft);

endmodule
