/* --------------------------------------------------------
 *  bcd to 7-seg LED decoder (functionCcaseo[W)
 *	(bcd7seg2.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module bcd7seg(bcd, seg);
    input  [3:0] bcd;
    output [6:0] seg; // = [a, b, c, d, e, f, g]

    assign seg = bcd7segdec(bcd);
    
    function [6:0] bcd7segdec;
        input [3:0] bcd;
        begin
            case (bcd) 
                4'b0000: bcd7segdec = 7'b1111110;
                4'b0001: bcd7segdec = 7'b0110000;
                4'b0010: bcd7segdec = 7'b1101101;
                4'b0011: bcd7segdec = 7'b1111001;
                4'b0100: bcd7segdec = 7'b0110011;
                4'b0101: bcd7segdec = 7'b1011011;
                4'b0110: bcd7segdec = 7'b1011111;
                4'b0111: bcd7segdec = 7'b1110000;
                4'b1000: bcd7segdec = 7'b1111111;
                4'b1001: bcd7segdec = 7'b1111011;
                default: bcd7segdec = 7'b0110111; // X
            endcase
        end
    endfunction

endmodule
