/*
 *  bcd to 7-seg LED decoder (functionCifo[W)
 *      (bcd7seg4.v)    (C)2000 Shinya KIMURA
 */

module bcd7seg(bcd, seg);
    input  [3:0] bcd;
    output [6:0] seg; // = [a, b, c, d, e, f, g]

    assign seg = bcd7segdec(bcd);
    
    function [6:0] bcd7segdec;
        input [3:0] bcd;
        reg   [6:0] out;
        begin
            if(bcd==0)      out = 7'b1111110;
            else if(bcd==1) out = 7'b0110000;
            else if(bcd==2) out = 7'b1101101;
            else if(bcd==3) out = 7'b1111001;
            else if(bcd==4) out = 7'b0110011;
            else if(bcd==5) out = 7'b1011011;
            else if(bcd==6) out = 7'b1011111;
            else if(bcd==7) out = 7'b1110000;
            else if(bcd==8) out = 7'b1111111;
            else if(bcd==9) out = 7'b1111011;
            else            out = 7'b0110111; // X
            
            bcd7segdec = out;
        end
    endfunction
endmodule
