/* --------------------------------------------------------
 *  case and casex statement test
 *	(casetest.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module test_case(data, encode);
    input [3:0] data;
    output [2:0] encode;

    assign encode = encoder(data);

    function [2:0] encoder;
        input [3:0] indata;
        
        case(indata)
          4'b0001 : encoder = 3'b000;
          4'b0010 : encoder = 3'b001;
          4'b0100 : encoder = 3'b010;
          4'b1000 : encoder = 3'b011;
          4'bxxxx : encoder = 3'b111;
          default : encoder = 3'b100;
        endcase
    endfunction

endmodule


module test_casex(data, encode);
    input [3:0] data;
    output [2:0] encode;

    assign encode = encoder(data);

    function [2:0] encoder;
        input [3:0] indata;
        
        casex(indata)
          4'b0001 : encoder = 3'b000;
          4'b001x : encoder = 3'b001;
          4'b01xx : encoder = 3'b010;
          4'b1xxx : encoder = 3'b011;
          default : encoder = 3'b100;
        endcase
    endfunction

endmodule


module test_casex_q(data, encode);
    input [3:0] data;
    output [2:0] encode;

    assign encode = encoder(data);

    function [2:0] encoder;
        input [3:0] indata;
        
        casex(indata)
          4'b1??? : encoder = 3'b011;
          4'b?1?? : encoder = 3'b010;
          4'b??1? : encoder = 3'b001;
          4'b???1 : encoder = 3'b000;
          default : encoder = 3'b100;
        endcase
    endfunction

endmodule
