/* --  V~[V  ------------------------------
 *  case, casex comparison
 *	(casesim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */
 

module casesim();
    reg  [3:0] data;
    wire [2:0] encode1, encode2, encode3;

    test_case    case1(data, encode1);
    test_casex   case2(data, encode2);
    test_casex_q case3(data, encode3);
   
    initial begin
        $monitor("%t: %b -> %b   %b   %b", $time, data, encode1, encode2, encode3);
        $display("                TIME: [IN] -> case  casex casex_?");
        $display("-------------------------------------------------");
    end

    initial begin
      #10
        data <= 4'b0000;
      #10
        data <= 4'b0001;
      #10
        data <= 4'b0010;
      #10
        data <= 4'b0100;
      #10
        data <= 4'b1000;
      #10
        data <= 4'b1111;
      #100
        data <= 4'bxxx1;
      #10
        data <= 4'bxx1x;
      #10
        data <= 4'bx1xx;
      #10
        data <= 4'b1xxx;
      #10
        data <= 4'b0010;
      #10
        data <= 4'bxx10;
      #10
        data <= 4'b001x;
      #10
        data <= 4'bxx1x;
      #10
        data <= 4'bxxxx;
        $finish;
    end

endmodule

