/* --------------------------------------------------------
 *  4-bit counter with async. reset
 *      (count4.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module count4(clock, reset_N, count);
    input        clock;  	// count up trigger
    input        reset_N;	// reset (active low)
    output [3:0] count;

    reg    [3:0] count;

    always @(posedge clock or negedge reset_N) begin
        if(!reset_N) begin
            count <= 4'b0000;
        end else begin
            count <= count + 1;
        end
    end
endmodule
