/* --------------------------------------------------------
 *  4-bit counter with enable & async. reset
 *      (count4en.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module count4en(clock, enable, reset_N, count);
    input        clock;  	// count up trigger
    input        enable;	// count enable
    input        reset_N;	// reset (active low)
    output [3:0] count;

    reg    [3:0] count;

    always @(posedge clock or negedge reset_N) begin
        if(!reset_N) begin
            count <= 4'b0000;
        end else if(enable) begin
            count <= count + 1;
        end
    end
endmodule
