/* --------------------------------------------------------
 *  bcd to 7-seg LED decoder (functionCifo[W)
 *	(bcd7seg1.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module bcd7seg(bcd, seg);
    input  [3:0] bcd;
    output [6:0] seg; // = [a, b, c, d, e, f, g]

    assign seg = bcd7segdec(bcd);
    
    function [6:0] bcd7segdec;
        input [3:0] bcd;
        begin
            if(bcd==0)      bcd7segdec = 7'b1111110;
            else if(bcd==1) bcd7segdec = 7'b0110000;
            else if(bcd==2) bcd7segdec = 7'b1101101;
            else if(bcd==3) bcd7segdec = 7'b1111001;
            else if(bcd==4) bcd7segdec = 7'b0110011;
            else if(bcd==5) bcd7segdec = 7'b1011011;
            else if(bcd==6) bcd7segdec = 7'b1011111;
            else if(bcd==7) bcd7segdec = 7'b1110000;
            else if(bcd==8) bcd7segdec = 7'b1111111;
            else if(bcd==9) bcd7segdec = 7'b1111011;
            else            bcd7segdec = 7'b0110111; // X
        end
    endfunction
endmodule
