/* --------------------------------------------------------
 *  BCD up/down counter with async. reset 
 *	(udcount4.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module udcount4(clock, up, down, reset_N, count, carry, borrow);
    input        clock;  	// count trigger
    input        up, down;	// count up & down
    input        reset_N;	// reset (active low)
    output [3:0] count;         // count value
    output       carry, borrow; // to next degit

    reg    [3:0] count;
    wire         carry, borrow;

    assign carry  = ((count==9) &&  up && !down) ? 1 : 0;
    assign borrow = ((count==0) && !up &&  down) ? 1 : 0;

    always @(posedge clock or negedge reset_N) begin
        if(!reset_N) begin
            count <= 4'b0000;
        end else if(up && !down) begin
            if(count==9) begin
                count <= 0;
            end else begin
                count <= count + 1;
            end
        end else if(!up && down) begin
            if(count==0) begin
                count <= 9;
            end else begin
                count <= count - 1;
            end
        end
    end
endmodule
