/* --------------------------------------------------------
 *    4-bit loadable counter
 *        (ldcount4.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module ldcount4(clock, load, in_data, count);
    input        clock;		// count trigger
    input        load;		// load enable
    input  [3:0] in_data;
    output [3:0] count;

    reg    [3:0] count;

    always @(posedge clock) begin
        if(load) begin
            count <= in_data;
        end else begin
            count <= count + 1;
        end
    end
endmodule

