/* --  V~[V  ------------------------------
 *  2-digit 4-bit up/down counter with async. reset
 *	(udcont4sim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module udcount4sim();
    reg        clk, up, dn, rst_N;
    wire [3:0] c_out1, c_out2;
    wire       cy1, cy2, br1, br2;

  // ݌vΏۂ̃CX^VF[V
    udcount4 udc4_1(clk, up,  dn,  rst_N, c_out1, cy1, br1);
    udcount4 udc4_2(clk, cy1, br1, rst_N, c_out2, cy2, br2);

  // ϑM̎w
    initial begin
        $display("                      c        r                   ");
        $display("                      l     d  e                   ");
        $display("                      o     o  s  c b           c b");
        $display("                      c  u  w  e  y r    1      y r") ;
        $display("                TIME: k  p  n  t  1 1    0    1 2 2");
        $display("----------------------+--+--+--+--+-+----+----+-+-+-");
        $monitor("%t: %b  %b  %b  %b  %b %b %b %b %b %b",
                  $time, clk, up, dn, rst_N, cy1, br1,
                  c_out2, c_out1, cy2, br2);
    end

  // eXgM
    initial begin		// JEgNbNM
        clk <= 0;
    end

    always #10 begin		// JEgNbNU
        clk <= !clk;
    end

    initial begin
        up      <= 1'b0;	// JEgCl[u
        dn      <= 1'b0;	// 
        rst_N   <= 1'b1;	// ZbgM
      @(negedge clk)
        rst_N   <= 1'b0;	// ZbgMANeBu
      @(negedge clk)
        rst_N   <= 1'b1;	// ZbgMCANeBu
      @(negedge clk)
        up      <= 1'b1;	// JEgAbv
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
        up      <= 1'b0;	// JEg_E
        dn      <= 1'b1;
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
        dn      <= 1'b0;	// JEgXgbv
      @(negedge clk)
      @(negedge clk)
        up      <= 1'b1;	// AbvE_E
        dn      <= 1'b1;
      @(negedge clk)
      @(negedge clk)
        rst_N   <= 1'b0;	// Zbg
      @(negedge clk)
        rst_N   <= 1'b1;
      @(negedge clk)
      @(negedge clk)
        up      <= 1'b0;	// JEg_E
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
        up      <= 1'b1;	// JEgAbv
        dn      <= 1'b0;
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
      @(negedge clk)
      $finish;			// V~[VI
    end
endmodule
