/* --------------------------------------------------------
 *  sample fo "generate" & "for loop" 
 *                  (a part of LED matrix control module)
 *	(gen_for.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module mtrxcont(xtal, reset_N, ledmtrx);
    input         xtal;		// clock
    input         reset_N;	// reset (active low)
    output [63:0] ledmtrx;	// LED matrix

    wire [63:0] ledmtrx;
    reg         ledmtrx2d [0:7][0:7];

    genvar xx, yy;		// loop counter for "generate"

    generate
        for(yy=0; yy<8; yy=yy+1) begin: dim2to0_1
            for(xx=0; xx<8; xx=xx+1) begin: dim2to0_2
                assign ledmtrx[yy*8+xx]=ledmtrx2d[xx][yy];
            end
        end
    endgenerate

    integer i, j;		// loop counter for "for-loop"

    always @(posedge xtal or negedge reset_N) begin
        if(!reset_N) begin
	    for(i=0; i<8; i=i+1) begin
	        for(j=0; j<8; j=j+1) begin
	            ledmtrx2d[i][j] <= 1'b0;
                end
            end
        end else begin
            // RT operation
        end
    end
endmodule
