/* --------------------------------------------------------
 *  parity check using for-loop
 *	(parity_for.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module parity_for(data, odd_parity);
    input  [7:0] data;
    output       odd_parity;
    wire         odd_parity;

    function parity;
        input [7:0] data;
        reg   [3:0] sum;
        integer     i;
        
        begin
            sum = 0;
            for(i=0; i<8; i=i+1) begin
                sum = sum + data[i];
            end
            parity = sum[0];
        end
    endfunction

    assign odd_parity = parity(data);

endmodule
