/* --  Altera FLEX10K _pgbvW[  ---------
 *  parameter
 *	(paramtop.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */


module paramtop(regsel, wr, we, data_in, data_out);
    input  [ 2:0] regsel;
    input         wr, we;
    input  [31:0] data_in;
    output [31:0] data_out;

    wire   [ 7:0] reg8out;
    wire   [15:0] reg16out;
    wire   [31:0] reg32out;

    assign data_out = (regsel==1) ? {24'h000000, reg8out}  : 32'hZZZZZZZZ;
    assign data_out = (regsel==2) ? {16'h0000,   reg16out} : 32'hZZZZZZZZ;
    assign data_out = (regsel==4) ? {            reg32out} : 32'hZZZZZZZZ;

    register #( 8) reg8  (wr, we, data_in[ 7:0], reg8out);
    register #(16) reg16 (wr, we, data_in[15:0], reg16out);
    register #(32) reg32 (wr, we, data_in,       reg32out);

endmodule
