/* --------------------------------------------------------
 *  3 parameters sample
 *	(param3.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module sram(adrs, data, cs, rd, wr);
    parameter DATA_WIDTH = 4, ADRS_WIDTH = 4, WORD_NO = 16;
    input [ADRS_WIDTH-1:0] adrs;
    input                  rd, cs, wr;
    inout [DATA_WIDTH-1:0] data;

    wire  [ADRS_WIDTH-1:0] adrs;
    wire                   rd, cs, wr;
    wire  [DATA_WIDTH-1:0] data;

    reg   [DATA_WIDTH-1:0] mem [0:WORD_NO-1];

  // read operation
    assign data = (cs && rd) ? mem[adrs] : 8'hZZ;

  // write operation
    always @(adrs or data or cs or wr) begin
        if(cs && wr) begin
            mem[adrs] <= data;
        end
    end
    
endmodule
