/* --------------------------------------------------------
 *  multplexer (logic equation version)
 *	(mltplx2.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

// 1-bit two input multiplexer
module mux1_2(sel, in0, in1, out);
    input  sel, in0, in1;
    output out;

    assign out = sel & in1 | ~sel & in0;

endmodule

// 4-bit four input multiplexer
module mux4_4(sel, in0, in1, in2, in3, out);
    input  [1:0] sel;
    input  [3:0] in0, in1, in2, in3;
    output [3:0] out;

    assign out[0] = ~sel[1] & ~sel[0] & in0[0] |
                    ~sel[1] &  sel[0] & in1[0] |
                     sel[1] & ~sel[0] & in2[0] |
                     sel[1] &  sel[0] & in3[0] ;

    assign out[1] = ~sel[1] & ~sel[0] & in0[1] |
                    ~sel[1] &  sel[0] & in1[1] |
                     sel[1] & ~sel[0] & in2[1] |
                     sel[1] &  sel[0] & in3[1] ;

    assign out[2] = ~sel[1] & ~sel[0] & in0[2] |
                    ~sel[1] &  sel[0] & in1[2] |
                     sel[1] & ~sel[0] & in2[2] |
                     sel[1] &  sel[0] & in3[2] ;

    assign out[3] = ~sel[1] & ~sel[0] & in0[3] |
                    ~sel[1] &  sel[0] & in1[3] |
                     sel[1] & ~sel[0] & in2[3] |
                     sel[1] &  sel[0] & in3[3] ;

endmodule
