
/* --  V~[V  ------------------------------
 *  multiplier (stop control version)
 *	(multi4scsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

`define PIRIOD 100

module multi_test;
    reg        clock, reset_N, wrstb_N, MLsel, start_N;
    reg  [3:0] sw_data;
    wire       ready_N;
    wire [4:0] Hreg;
    wire [3:0] Lreg;

  // ݌vΏۂ̃CX^VF[V
    multiplier multi (clock, reset_N, wrstb_N, MLsel, 
                       sw_data, start_N, ready_N, Hreg, Lreg  );

  // ϑM̎w
    initial begin
        $display("\t\t        r s        w   r                           ");
        $display("\t\t      c e t        r   e           M    H     L    ");
        $display("\t\t      l s a        s   a           r    r     r    ");
        $display("\t\t      o e r   s    t   d   I A S   e    e     e    ");
        $display("\t\t      c t t   w    b   y   s s s   g    g     g    ");
        $display("\t\ttime| k - -   3210 -   -   t t t   3210 43210 3210 ");
        $display("--------------------+-------+--------+---+-------+----------------");
        $monitor("%t: %b %b %b : %b %b : %b : %b %b %b : %b %b %b", 
                 $time, clock, reset_N, start_N, sw_data, wrstb_N,
                 ready_N, multi.Istate, multi.Astate, multi.Sstate, 
                 multi.Mreg, Hreg, Lreg);
    end

  // eXgM
    initial begin
        clock    <= 1'b0;
        reset_N  <= 1'b1;
        wrstb_N  <= 1'b1;
        MLsel    <= 1'b0;
        sw_data  <= 4'b0000;
        start_N  <= 1'b1;
        
      #`PIRIOD
        reset_N <= 1'b0;
      #(`PIRIOD*2)
        reset_N <= 1'b1;	// reset off
      #(`PIRIOD/2)
        sw_data <= 4'b0101;	// setting data to Mreg
        MLsel   <= 1'b1;
      #(`PIRIOD/2)
        wrstb_N <= 1'b0;	// write strobe on
      #`PIRIOD
      #`PIRIOD
        wrstb_N <= 1'b1;
      #(`PIRIOD/2)
        sw_data <= 4'b0111;	// setting data to Lreg
        MLsel   <= 1'b0;
      #(`PIRIOD/2)
        wrstb_N <= 1'b0;	// wreite strobe on
      #`PIRIOD
        wrstb_N <= 1'b1;
      #`PIRIOD
        start_N <= 1'b0;	// start on
      #`PIRIOD
        start_N <= 1'b1;
      #(`PIRIOD*10)
      $finish;
    end

  // NbN
    always #(`PIRIOD/2) begin
        clock <= ~clock;
    end

endmodule
