/* --------------------------------------------------------
 *  sample of array of instances (8 x (8 x (1-bit tbuf)))
 *	(tbuf_64.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module tbuf_64(en, in, out);
    input         en;
    input  [63:0] in;
    output [63:0] out;

  // (8-bit 3 state buffer) x 8
    tbuf_8 tbuf_8[7:0] (en, in, out);
    
endmodule


module tbuf_8(en, in, out);
    input        en;
    input  [7:0] in;
    output [7:0] out;

  // (1-bit 3 state buffer) x 8
    tbuf_1 tbuf_1[7:0] (en, in, out);

endmodule


module tbuf_1(en, in, out);
    input  en;
    input  in;
    output out;

  // 1-bit 3 state buffer
    assign out = (en) ? in : 1'bZ;

endmodule
