/* --------------------------------------------------------
 *  multiplexer (function͐Mrbgsv)
 *	(muxfuncxx.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

// 4-bit four input multiplexer
module mux4_4(sel, in0, in1, in2, in3, out);
    input  [1:0] sel;
    input  [4:0] in0, in1, in2, in3;
    output [4:0] out;

  // multilpexer function
    function [2:0] mux;
        input [1:0] sl;
        input [1:0] d0, d1, d2, d3;
        begin
            case(sl)
                0      : mux = d0;
                1      : mux = d1;
                2      : mux = d2;
                3      : mux = d3;
                default: mux = 4'bxxxx;
            endcase
        end
    endfunction
    
    assign out = mux(sel, in0, in1, in2, in3);
    
endmodule

