/* --  V~[V  ------------------------------
 *  register alu test bench
 *	(ralusim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

`define ADD 0
`define SUB 1
`define AND 2
`define OR  3

module ralu_sim();
    reg        clock, we_N;
    reg        xwr_N, xrd_N;
    reg  [7:0] setdata;
    reg  [2:0] regsel_l, regsel_r, regsel_w;
    reg  [1:0] aluop;

    wire [7:0] data;

  // ݌vΏۂ̃CX^VF[V
    ralu ralu(clock, data, we_N, xwr_N, xrd_N, 
              regsel_l, regsel_r, regsel_w, aluop);

    assign data = xwr_N ? 8'hZZ : setdata;

  // ϑM̎w
    initial begin
        $monitor("%4t: clock=%b | data=%h | we_N= %b xwr_N=%b xrd_N=%b | reg_l=%h reg_r=%h reg_w=%h aluop=%h",
                  $time, clock, data, we_N, xwr_N, xrd_N,
                  regsel_l, regsel_r, regsel_w, aluop);
    end


  // eXgM
    initial begin
        clock <= 0;
        xwr_N <= 1;
        xrd_N <= 1;
      @(negedge clock)
      @(negedge clock)
      @(negedge clock)
      @(negedge clock)		// register set
        xwr_N    <= 0;
        we_N     <= 0;
        setdata  <= 8'hF0;
        regsel_w <= 0;
      @(negedge clock)
        setdata  <= 8'h5A;
        regsel_w <= 1;
      @(negedge clock)
        setdata  <= 8'hC3;
        regsel_w <= 2;
      @(negedge clock)
        setdata  <= 8'h96;
        regsel_w <= 3;
      @(negedge clock)		// register read
        xwr_N    <= 1;
        we_N     <= 1;
        xrd_N    <= 0;
        regsel_l <= 0;
      @(negedge clock)
        regsel_l <= 1;
      @(negedge clock)
        regsel_l <= 2;
      @(negedge clock)
        regsel_l <= 3;

      @(negedge clock)	// operation
        we_N     <= 0;
        regsel_l <= 0;
        regsel_r <= 1;
        regsel_w <= 4;
        aluop    <= `ADD;
      @(negedge clock)
        regsel_l <= 0;
        regsel_r <= 1;
        regsel_w <= 5;
        aluop    <= `SUB;
      @(negedge clock)
        regsel_l <= 0;
        regsel_r <= 1;
        regsel_w <= 6;
        aluop    <= `AND;
      @(negedge clock)
        regsel_l <= 0;
        regsel_r <= 1;
        regsel_w <= 7;
        aluop    <= `OR;
      @(negedge clock)		// register read
        we_N     <= 1;
        xrd_N    <= 0;
        regsel_l <= 4;
      @(negedge clock)
        regsel_l <= 5;
      @(negedge clock)
        regsel_l <= 6;
      @(negedge clock)
        regsel_l <= 7;
      @(negedge clock)
        $finish;
    end

  // NbNU
    always # 50 begin
        clock <= ~clock;
    end

endmodule
