/* --------------------------------------------------------
 *   positive edge trigger with asynchronous reset and preset
 *	(reg4_rst_pst.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module reg4arstpst(wr_stb, reset_N, preset_N, in_data, out_data);
    input        wr_stb;
    input        reset_N;
    input        preset_N;
    input  [3:0] in_data;
    output [3:0] out_data;

    reg    [3:0] out_data;

    always @(posedge wr_stb or negedge reset_N or negedge preset_N) begin
        if(!reset_N) begin
            out_data <= 4'b0000;
        end else if(!preset_N) begin
            out_data <= 4'b1111;
        end else begin
            out_data <= in_data;
        end
    end
endmodule
