/* --  V~[V  ------------------------------
 *  register with reset and preset
 *	(reg_r_p_sim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module reg4_rst_pst_test_bench();
    reg        wr_stb, rst_N, pst_N;
    reg  [3:0] in_data;
    wire [3:0] out_data; 

    reg4arstpst U1(wr_stb, rst_N, pst_N, in_data, out_data);
    
    initial begin
        $monitor("W=%b, R_N=%b, P_N=%b, in=%b => out=%b",
                  wr_stb, rst_N, pst_N, in_data, out_data);
    end
    
    initial begin 
        wr_stb  <= 1'b0;
        rst_N   <= 1'b1;
        pst_N   <= 1'b1;
        in_data <= 4'b1010;
    end

    initial begin
        rst_N   <= 1'b0;
      #10
        rst_N   <= 1'b1;
      #10
        wr_stb  <= 1'b1;
      #10
        wr_stb  <= 1'b0;
      #10
        pst_N   <= 1'b0;
      #10
        pst_N   <= 1'b1;
      #10
        rst_N   <= 1'b0;
        pst_N   <= 1'b0;
      #10
        rst_N   <= 1'b0;
        pst_N   <= 1'b1;
      #10
        rst_N   <= 1'b1;
        pst_N   <= 1'b1;
      #10
        rst_N   <= 1'b0;
        pst_N   <= 1'b0;
      #10
        rst_N   <= 1'b1;
        pst_N   <= 1'b0;
      #10
        rst_N   <= 1'b1;
        pst_N   <= 1'b1;
      #10
        rst_N   <= 1'b0;
        pst_N   <= 1'b0;
      #10
        rst_N   <= 1'b1;
        pst_N   <= 1'b1;
      #10
       $finish;
    end
endmodule
