/* --------------------------------------------------------
 *  SRAM bit field
 *	(file name)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module SRAM8x4(adrs, data, rd, wr, u_nbl, l_nbl);
    input [1:0] adrs;
    inout [7:0] data;
    input       rd;
    input       wr;
    input       u_nbl;
    input       l_nbl;

    reg [7:0] mem [0:3];

    assign data[7:4] = (rd & u_nbl) ? mem[adrs][7:4] : 4'bZZZZ;
    assign data[3:0] = (rd & l_nbl) ? mem[adrs][3:0] : 4'bZZZZ;


    always @(adrs, data, wr) begin
        if(wr) begin
            mem[adrs][3:0] <= data[7:4];
        end
    end



/*
    always @(adrs, data, wr) begin
        if(wr) begin
            mem[adrs] <= data;
        end
    end
*/
/* next is impossible to synthesize (XST for XC95)
    always @(adrs, data, wr) begin
        if(wr) begin
            if(u_nbl && !l_nbl) begin
                mem[adrs][7:4] <= data[7:4];
            end else if(!u_nbl && l_nbl) begin
                mem[adrs][3:0] <= data[3:0];
            end else if( u_nbl && l_nbl) begin
                mem[adrs]      <= data;
            end
        end
    end
*/

endmodule
