/* --  V~[V  ------------------------------
 *  register
 *	(registersim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module reg_test_bench();
    reg        wr_stb, reset_N, enable;
    reg  [3:0] in;
    wire [3:0] out, outsr, outar, outear, outlvl;

  // ݌vΏۂ̃CX^VF[V
    reg4       reg4       (wr_stb,                  in, out);
    reg4srst   reg4srst   (wr_stb, reset_N,         in, outsr);
    reg4arst   reg4arst   (wr_stb, reset_N,         in, outar);
    reg4enarst reg4enarst (wr_stb, reset_N, enable, in, outear);
    reg4lvl    reg4lvl    (wr_stb,                  in, outlvl);

  // ϑM̎w
    initial begin
        $display("                    : w r e |      simple type");
        $display("                    : r e n |      |    sync reset");
        $display("                    : s s a |      |    |    async reset");
        $display("                    : t e b | i    |    |    |    enable async reset");
        $display("                Time: b t l | n    |    |    |    |    level");
        $display("--------------------:-------+----------------------------------");
        $monitor("%t: %b %b %b | %b %b %b %b %b %b", $time, wr_stb, reset_N, enable, 
                                 in, out, outsr, outar, outear, outlvl);
    end

  // eXgM
    initial begin
      // basic register test
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0001;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b0001;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0010;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0100;
      #10
      // register with sync reset
        wr_stb <= 0; reset_N <= 0; enable <= 0; in<= 4'b0011;
      #10
        wr_stb <= 1; reset_N <= 0; enable <= 0; in<= 4'b0011;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0100;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b0100;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0000;
      #10
      // register with async reset
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b0100;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b1000;
      #10
        wr_stb <= 0; reset_N <= 0; enable <= 0; in<= 4'b1111;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b1100;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b1100;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0011;
      #10
      // register with enable and async reset
        wr_stb <= 1; reset_N <= 0; enable <= 0; in<= 4'b0100;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 1; in<= 4'b1001;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 1; in<= 4'b1001;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b1100;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b1100;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0011;
      #10
      // high level trigger
        wr_stb <= 0; reset_N <= 0; enable <= 0; in<= 4'b0100;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b1001;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b1001;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b1100;
      #10
        wr_stb <= 1; reset_N <= 1; enable <= 0; in<= 4'b0110;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b0011;
      #10
        wr_stb <= 0; reset_N <= 1; enable <= 0; in<= 4'b1001;
      #10
        $finish;
    end
endmodule
