/* --  V~[V  ------------------------------
 *  shift register description test bench
 *	(sftreg_sim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module sfterg_test();
    reg clock, in;
    wire out1, out2, out3, out4, out5, out6;

    sftreg_nb sftreg_nb (clock, in, out1, out2);
    sftreg_b1 sftreg_b1 (clock, in, out3, out4);
    sftreg_b2 sftreg_b2 (clock, in, out5, out6);

    initial begin
        $display("                                    | non-blocking   | blocking-1     | blocking-2   ");
        $display("                                    |  out1 <= in;   |  out2 = in;    |  out6 = out5;");
        $display("                 time:              |  out2 <= out1; |  out3 = out2;  |  out5 = in;  ");
        $display("------------------------------------+----------------+----------------+----------------");
    end

    initial begin
        $monitor("%t : clock=%b in=%b |  out1=%b out2=%b |  out3=%b out4=%b |  out5=%b out6=%b",
                 $stime, clock, in, out1, out2, out3, out4, out5, out6);
    end
    
    initial begin
        in = 0; clock = 0; // ݒ
      #10
        in = 0; clock = 1;
      #10
        in = 1; clock = 0;
      #10
        in = 1; clock = 1;
      #10
        in = 0; clock = 0;
      #10
        in = 0; clock = 1;
      #10
        in = 1; clock = 0;
      #10
        in = 1; clock = 1;
      #10
        in = 0; clock = 0;
      #10
        in = 0; clock = 1;
      #10
        $finish;
    end
endmodule
