/* --------------------------------------------------------
 *  fever led control for slot machine game
 *	(fever.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module fever_led(clock, run_stop, fever, led);
    input        clock;
    input        run_stop;
    input        fever;
    output [7:0] led;

    wire   [7:0] led;
    reg    [1:0] disp;

    function [7:0] led_on_off;
        input [1:0] disp;
        input       run_stop;
        input       fever;

        begin
            if(!run_stop) begin
                if(!fever) begin
                    led_on_off = 8'b1000_0001;
                end else begin
                    led_on_off = (disp==2'b00) ? 8'b0001_1000 :
                                 (disp==2'b01) ? 8'b0010_0100 :
                                 (disp==2'b10) ? 8'b0100_0010 :
                                 (disp==2'b11) ? 8'b1000_0001 :
                                                 8'b0000_0000 ;
                end
            end else begin
                led_on_off = disp[0] ? 8'b0000_0000 : 8'b1000_0001;
            end
        end

    endfunction 

    always @(posedge clock) begin
        disp <= disp + 1;
    end

    assign led = led_on_off(disp, run_stop, fever);

endmodule
