/* --------------------------------------------------------
 *  slot machine game system
 *	(slot_sys.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module system(clock, d_clock, reset_N, start, stop, digit, seg_led, led);
    input        clock, d_clock, reset_N;
    input        start;
    input  [2:0] stop;
    output [3:0] digit;
    output [7:0] seg_led;
    output [7:0] led;

    wire [2:0] left, middle, right, d_dgt;

    slot_body U0(clock, reset_N, start, stop, left, middle, right, run_stop, fever);
    fever_led U1(clock, run_stop, fever, led);
    pattern   U2(d_dgt, seg_led);
    dynamic   U3(d_clock, left, middle, right, digit, d_dgt);

endmodule
