/* --  V~[V  ------------------------------
 *  slot machine game test bench (for slot_body)
 *	(slotsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

 module slotsim();
    reg        clk, rst_N;
    reg        start;
    reg  [2:0] stop;

    wire [2:0] left, middle, right;
    wire       run_stop, fever;

  // ݌vΏۂ̃CX^VF[V

    slot_body S0(clk, rst_N, start, stop, left, middle, right, run_stop, fever);

  // ϑM̎w
    initial begin
        $display("                      c r | s   s          |   f |  tt     | ");
        $display("                      l s | t   t          |   e |  oo rrr | ");
        $display("                      o t | a   o    L M R | r v | tuu uuu | ");
        $display("                      c | | r   p    F D G | u e | rtt nnn | ");
        $display("                TIME: k N | t 210    T L T | n r | g12 LMR | LS MS RS");
        $display("----------------------+-+-+----------------+-----+---------+---------");
        $monitor("%t: %b %b | %b %b -> %d %d %d | %b %b | %b%b%b %b%b%b | %b %b %b",
                  $time, clk, rst_N, start, stop, left, middle, right, run_stop, fever,
                  S0.start_trg, S0.time_out1, S0.time_out2, S0.runL, S0.runM, S0.runR,
                  S0.LS.state, S0.MS.state, S0.RS.state, );
    end

  // M
    initial begin
        clk   <= 1'b0;
        rst_N <= 1'b0;
        start <= 1'b0;
        stop  <= 3'b000;
    end

  // NbNU
    always #50 begin
        clk <= !clk;
    end

  // ^XN
    task wait_posedge_clk;
        input   n;
        integer n;

        begin
            for( n=n; n>0; n=n-1) begin
                @(posedge clk)
                  ;	// empty
            end
        end
    endtask

    task stop_sw;
        input   sw_no, width;
        integer sw_no, width;

        begin
            @(posedge clk)
            stop[sw_no] = 1'b1;
            wait_posedge_clk(width);
            stop[sw_no] = 1'b0;
        end
    endtask

    task start_sw;
        input   width;
        integer width;

        begin
            @(posedge clk)
            start = 1'b1;
            wait_posedge_clk(width);
            start = 1'b0;
        end
    endtask


  // eXgM
    initial begin
        $write("Reset ----\n");
        wait_posedge_clk(4);
        rst_N <= 1'b1;		// Zbg

        $write("Game start ----\n");
        wait_posedge_clk(5);
        start_sw(4);		// X^[g
        wait_posedge_clk(25);

        $write("Stop left side ----\n");
        stop_sw(2, 2);		// XgbvQ
        wait_posedge_clk(2);

        $write("Stop rigth side ----\n");
        stop_sw(0, 2);		// XgbvO
        wait_posedge_clk(2);

        $write("Stop middle side ----\n");
        stop_sw(1, 2);		// XgbvP

        wait_posedge_clk(10);
        $write("Game start ----\n");
        start_sw(8);		// X^[g
        wait_posedge_clk(25);

        wait(right == 3'b000)	// p^[҂ & XgbvO
        $write("Stop right side ----\n");
        stop_sw(0, 1);
        wait_posedge_clk(4);

        wait(left == 3'b000)	//  p^[҂ & XgbvQ
        $write("Stop left side ----\n");
        stop_sw(2, 2);
        wait_posedge_clk(4);

        wait(middle == 3'b000)	//  p^[҂ & XgbvP
        $write("Stop middle side ----\n");
        stop_sw(1, 3);
        wait_posedge_clk(10);

        $finish;		// V~[VI
    end
endmodule
