/* --------------------------------------------------------
 *  static RAM (8-bit x 1024-ward)
 *	(sram.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module sram(adrs, data, cs, rd, wr);
    input [9:0] adrs;
    input       rd, cs, wr;
    inout [7:0] data;

    wire  [9:0] adrs;
    wire        rd, cs, wr;
    wire  [7:0] data;

    reg   [7:0] mem[1023:0];

  // read operation
    assign data = (cs && rd) ? mem[adrs] : 8'hZZ;

  // write operation
    always @(adrs or data or cs or wr) begin
        if(cs && wr) begin
            mem[adrs] <= data;
        end
    end
    
endmodule
