/* --  V~[V  ------------------------------
 *  static RAM
 *	(sramsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module sramtest();
    reg  [9:0] adrs;
    reg  [7:0] wdata;
    reg        cs, rd, wr;
    wire [7:0] data;

  // sram module instantiation
    sram sram (adrs, data, cs, rd, wr);
    
  // data bus 
    assign data = wr ? wdata : 8'hZZ;

  // sram initilaize
    initial begin
        $readmemb("data.bin", sram.mem);
    end
  // monitoring signal
    initial begin
        $monitor("%4t: %h, %h, %b, %b, %b", $time, adrs, data, cs, rd, wr);
    end

  // test
    initial begin
      // read test
        adrs <= 16'h000; wdata <= 8'hZZ; cs <= 0; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h000; wdata <= 8'hZZ; cs <= 1; rd <= 1; wr <= 0;
      #10
        adrs <= 16'h001; wdata <= 8'hZZ; cs <= 1; rd <= 1; wr <= 0;
      #10
        adrs <= 16'h002; wdata <= 8'hZZ; cs <= 1; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h002; wdata <= 8'hZZ; cs <= 1; rd <= 1; wr <= 0;
      #10
        adrs <= 16'h002; wdata <= 8'hZZ; cs <= 0; rd <= 1; wr <= 0;
      #10

      // write test
        adrs <= 16'h101; wdata <= 8'h12; cs <= 1; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h101; wdata <= 8'h12; cs <= 1; rd <= 0; wr <= 1;
      #10
        adrs <= 16'h101; wdata <= 8'h12; cs <= 1; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h101; wdata <= 8'hZZ; cs <= 1; rd <= 1; wr <= 0;
      #10
        adrs <= 16'h101; wdata <= 8'h34; cs <= 0; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h101; wdata <= 8'h34; cs <= 0; rd <= 0; wr <= 1;
      #10
        adrs <= 16'h101; wdata <= 8'h34; cs <= 0; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h101; wdata <= 8'h34; cs <= 1; rd <= 1; wr <= 0;
      #10

        adrs <= 16'h122; wdata <= 8'h34; cs <= 0; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h122; wdata <= 8'h34; cs <= 1; rd <= 0; wr <= 1;
      #10
        adrs <= 16'h122; wdata <= 8'h56; cs <= 1; rd <= 0; wr <= 1;
      #10
        adrs <= 16'h133; wdata <= 8'h56; cs <= 1; rd <= 0; wr <= 1;
      #10
        adrs <= 16'h133; wdata <= 8'hZZ; cs <= 0; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h122; wdata <= 8'hZZ; cs <= 1; rd <= 0; wr <= 0;
      #10
        adrs <= 16'h122; wdata <= 8'hZZ; cs <= 1; rd <= 1; wr <= 0;
      #10
        adrs <= 16'h133; wdata <= 8'hZZ; cs <= 1; rd <= 1; wr <= 0;
      #10
        adrs <= 16'h133; wdata <= 8'hZZ; cs <= 1; rd <= 0; wr <= 0;
      #10
        $finish;
    end
endmodule
