/* ---------------------------------------------------
 *  stepping motor contorller by software
 *      (stepmtcnt.c)       designed by Shinya KIMURA
 * --------------------------------------------------- */

#include <??.h>

/* external I/O port address */
#define SWITCH_PORT 0x??
#define CLOCK_POERT 0x??
#define STEPMT_PORT 0x??

/* control switch signal */
#define reset (sw & 0x80)
#define start (sw & 0x08)
#define right (sw & 0x04)
#define speed (sw & 0x03)

/* pulse pattern */
#define P0state 0x01
#define P0state 0x04
#define P0state 0x02
#define P0state 0x08

main()
{
    int sw, state;

    state = P0state;
    while(1) {
        sw = inportb(SWITCH_PORT);          /* switch signal input */
        if(reset){
            state = P0state;
            outportb(STEPMT_PORT, state);   /* drive pulse output  */
        } else if(start){
            if(right){    /* right rotation */
                switch (state) {
                    case P0state: state = P1state; break;
                    case P1state: state = P2state; break;
                    case P2state: state = P3state; break;
                    case P3state: state = P0state; break;
                    default     :                       ;
                }
            } else {      /* left rotation */
                switch (state) {
                    case P0state: state = P3state; break;
                    case P1state: state = P0state; break;
                    case P2state: state = P1state; break;
                    case P3state: state = P2state; break;
                    default     :                       ;
                }
            }
            outportb(STEPMT_PORT, state);   /* drive pulse output  */
            wait(speed);
        } else {
            /* stop */
        }
    }
}

void wait(int speed)
{
    switch (speed) {
        case 3 : while((inportb(CLOCK_PORT)&(0x01) == 1); /* clock input */
                 while((inportb(CLOCK_PORT)&(0x01) == 0);
        case 2 : while((inportb(CLOCK_PORT)&(0x01) == 1);
                 while((inportb(CLOCK_PORT)&(0x01) == 0);
        case 1 : while((inportb(CLOCK_PORT)&(0x01) == 1);
                 while((inportb(CLOCK_PORT)&(0x01) == 0);
        case 0 : while((inportb(CLOCK_PORT)&(0x01) == 1);
                 while((inportb(CLOCK_PORT)&(0x01) == 0); break;
        default:                                               ;
    }
}
