/* --------------------------------------------------------
 *  clock generator for slot machine game
 *	(clkgen.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module clock_gen(clk1MHz, clk1KHz, clk10Hz);
    input  clk1MHz;
    output clk1KHz, clk10Hz;

    wire   clk100KHz, clk10KHz;

    clkdiv10 C1 (  clk1MHz, clk100KHz);
    clkdiv10 C2 (clk100KHz,  clk10KHz);
    clkdiv10 C3 ( clk10KHz,   clk1KHz);
    clkdiv10 C4 (  clk1KHz,  clk100Hz);
    clkdiv10 C5 ( clk100Hz,   clk10Hz);
endmodule


module clkdiv10(orgclk, divedclk);
    input orgclk;
    output divedclk;

    reg [2:0] count;
    reg       divedclk;

    always @(posedge orgclk) begin
        if(count==3'b100) begin
            count <= 3'b000;
        end else begin
            count <= count + 1;
        end
    end

    always @(posedge count[2]) begin
        divedclk <= ~divedclk;
    end

endmodule
