/* --  V~[V  ------------------------------
 *  serial input variable length code decoder 
 *	(vldecsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module vldectest();
    wire [6:0] charsig, chardata;
    wire       a, b, c, d, e, f, g, dot;
    reg        clock, reset_N, sdata;
    
  // ݌vΏۂ̃CX^VF[V
    vldec   vldec   (clock, reset_N, sdata, charsig);

  // ϑM̎w
    initial begin 
        $display("                      C S                   charsig ");
        $display("                      L D   S S S S S S S           ");
        $display("                time: K T   0 1 2 3 4 5 X   ABCDEFG ");
        $display("--------------------:-----+---------------+---------");
    end

    initial begin
        $monitor("%t: %b %b | %b %b %b %b %b %b %b | %b",
                   $time, clock, sdata,
                   vldec.S0, vldec.S1, vldec.S2, vldec.S3,
                   vldec.S4, vldec.S5, vldec.SX, charsig);
    end

  // eXgM
    // clock generator
    always #50 begin
        clock <= ~clock;
    end

    task at_negedge_sdata;
        input s;
        begin
            @(negedge clock)
                sdata   <= s;
        end
    endtask

    initial begin
        clock   <= 0;
        reset_N <= 0;
        sdata   <= 0;
      @(posedge clock)
      @(posedge clock)
      @(posedge clock)
        reset_N <= 1;
      at_negedge_sdata(0);    // A
      at_negedge_sdata(0);
      at_negedge_sdata(0);    // B
      at_negedge_sdata(1);
      at_negedge_sdata(1);    // C
      at_negedge_sdata(0);
      at_negedge_sdata(0);
      at_negedge_sdata(1);    // D
      at_negedge_sdata(0);
      at_negedge_sdata(1);
      at_negedge_sdata(1);    // E
      at_negedge_sdata(1);
      at_negedge_sdata(0);
      at_negedge_sdata(1);    // F
      at_negedge_sdata(1);
      at_negedge_sdata(1);
      at_negedge_sdata(0);
      at_negedge_sdata(1);    // G
      at_negedge_sdata(1);
      at_negedge_sdata(1);
      at_negedge_sdata(1);
      @(negedge clock)
      @(negedge clock)
        $finish;
     end

endmodule
