/* --------------------------------------------------------
 *  7-segment LED character decoder 
 *	for variable length code decoder
 *	(leddec.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module leddec(charsig, sega, segb, segc, segd, sege, segf, segg, dot);
    input  [6:0] charsig;
    output       sega, segb, segc, segd, sege, segf, segg, dot;
    
    assign {sega, segb, segc, segd,
            sege, segf, segg, dot  } = charfig(charsig);

    function [7:0] charfig;
        input [6:0] char;

        case (char)
          7'b1000000: charfig = 8'b11101110;  // A
          7'b0100000: charfig = 8'b00111110;  // B
          7'b0010000: charfig = 8'b10011100;  // C
          7'b0001000: charfig = 8'b01111010;  // D
          7'b0000100: charfig = 8'b10011110;  // E
          7'b0000010: charfig = 8'b10001110;  // F
          7'b0000001: charfig = 8'b10111100;  // G
          default   : charfig = 8'b00000001;  // DOT
        endcase
    endfunction

endmodule
