/* --  Altera FLEX10K _pgbvW[  ---------
 *  serial input variable length code decoder  
 *	one-hot with led decoder (Mealy type)
 *	(vldecledtop.v)	designed by Shinya KIMURA
 * -------------------------------------------------------- */

module flextbtop(XTAL, RESET_N, CLKSEL, MANCLK, CHIPSEL_N, 
                 ADRSWR_N, DATAWR_N, DATARD_N, SW,
                 LED, EXTIORD_N, EXTIOWR_N, IOBUFIN_N, IOBUFEN_N,
                 LEDCLK_N, EXTIODATA, PCDATA);
                 
  // C^[tF[XM`
    input         XTAL;      // X'tal OSC
    input         RESET_N;   // reset
    input         CLKSEL;    // clock select
    input         MANCLK;    // manual switch clock
    input         CHIPSEL_N; // FPGA select
    input         ADRSWR_N;  // address port write strobe
    input         DATAWR_N;  // data port write strobe
    input         DATARD_N;  // data port read strobe
    input  [ 7:0] SW;        // switch input
    output [15:0] LED;       // LED output
    output        EXTIORD_N; // external I/O read strobe
    output        EXTIOWR_N; // external I/O write strobe
    output        IOBUFIN_N; // I/O buffer input
    output        IOBUFEN_N; // I/O buffer enable
    output        LEDCLK_N;  // clock LED
    inout  [ 7:0] EXTIODATA; // external I/O data
    inout  [ 7:0] PCDATA;    // host PC data

  // `bvM`
    wire          xtal, reset_N, clksel, manclk, clock;
    wire          chipsel_N, adrswr_N, datawr_N, datard_N;
    wire   [ 7:0] sw;
    wire   [15:0] led;
    wire   [ 6:0] charsig, chardata;

  // ͐Mڑ
    assign sw        = SW;
    assign xtal      = XTAL;
    assign reset_N   = RESET_N;
    assign clksel    = CLKSEL;
    assign manclk    = MANCLK;
    assign chipsel_N = CHIPSEL_N;
    assign adrswr_N  = ADRSWR_N;
    assign datawr_N  = DATAWR_N;
    assign datard_N  = DATARD_N;

  // o͐MftHgڑ
    assign EXTIORD_N = 1;
    assign EXTIOWR_N = 1;
    assign IOBUFIN_N = 0;
    assign IOBUFEN_N = 0;
    assign LED       = ~led;
//  assign led[15:0] = 16'h0000;

  // oMftHgڑ
    assign EXTIODATA = IOBUFIN_N                 ? sw[7:0] : 8'hZZ;
    assign PCDATA    = (!chipsel_N && !datard_N) ? sw[7:0] : 8'hZZ;

  // NbN͑I NbNLED\hCo[
    assign clock    = clksel ? xtal : manclk;
    assign LEDCLK_N = !clock;

  // ݌vΏۂ̃CX^VF[V
    vldec  vldec    (clock, reset_N, sw[0], charsig);
    charreg charreg (clock, charsig, chardata);
    leddec leddec   (chardata,
                     led[0],led[1],led[2],led[3],led[4],led[5],led[6],led[7]);

    assign led[ 8] = charsig[6];  // A
    assign led[ 9] = charsig[5];  // B
    assign led[10] = charsig[4];  // C
    assign led[11] = charsig[3];  // D
    assign led[12] = charsig[2];  // E
    assign led[13] = charsig[1];  // F
    assign led[14] = charsig[0];  // G
    assign led[15] = 0;           // dot

endmodule
