/* --  V~[V  ------------------------------
 *  serial input variable length code decoder 
 *	(vldecsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module vldectest();
    wire [6:0] charsig, chardata;
    wire       a, b, c, d, e, f, g, dot;
    reg        clock, reset_N, sdata;
    
  // ݌vΏۂ̃CX^VF[V
    vldec   vldec   (clock, reset_N, sdata, charsig);

  // ϑM̎w
    initial begin 
        $display("                      C S            charsig ");
        $display("                      L D                    ");
        $display("                time: K T    state   ABCDEFG ");
        $display("--------------------:-----+--------+---------");
    end

    initial begin
        $monitor("%t: %b %b | %b | %b",
                   $time, clock, sdata, vldec.state, charsig);
    end

  // eXgM
    // clock generator
    always #50 begin
        clock <= ~clock;
    end

    initial begin
        clock   <= 0;
        reset_N <= 0;
        sdata   <= 0;
      @(posedge clock)
      @(posedge clock)
      @(posedge clock)
      @(negedge clock)
        reset_N <= 1;
        sdata   <= 0;    // A
      @(negedge clock)
        sdata   <= 0;
      @(negedge clock)
        sdata   <= 0;    // B
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 1;    // C
      @(negedge clock)
        sdata   <= 0;
      @(negedge clock)
        sdata   <= 0;
      @(negedge clock)
        sdata   <= 1;    // D
      @(negedge clock)
        sdata   <= 0;
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 1;    // E
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 0;
      @(negedge clock)
        sdata   <= 1;    // F
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 0;
      @(negedge clock)
        sdata   <= 1;    // G
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
        sdata   <= 1;
      @(negedge clock)
      @(negedge clock)
        $finish;
     end

endmodule
