/* --  V~[V  ------------------------------
 *  serial input variable length code decoder
 *      led shape display version 
 *	(vldecledsim.v)		designed by Shinya KIMURA
 * -------------------------------------------------------- */

module vldecledtest();
    wire [6:0] charsig, chardata;
    wire       a, b, c, d, e, f, g, dot;
    reg        clock, reset_N, sdata;
    
  // ݌vΏۂ̃CX^VF[V
    vldec   vldec   (clock, reset_N, sdata, charsig);
    charreg charreg (clock, charsig, chardata);
    leddec  leddec  (chardata, a, b, c, d, e, f, g, dot);

  // LED`\^XN
    task leddisp;
        input a, b, c, d, e, f, g, dot;
        begin
            if(dot)
                $write(".\n");
            else begin 
                if(a) $write(" --\n"); else $write("\n");
                if(f) $write("|  ");   else $write("   ");
                if(b) $write("|\n");   else $write("\n");
                if(g) $write(" --\n"); else $write("\n");
                if(e) $write("|  ");   else $write("   \n");
                if(c) $write("|\n");   else $write("\n");
                if(d) $write(" --\n"); else $write("\n");
            end
        end
    endtask

  // eXgM
    // clock generator
    always #50 begin
        clock <= ~clock;
    end

    initial begin
        clock   <= 0;
        reset_N <= 0;
        sdata   <= 0;
      @(posedge clock) leddisp(a, b, c, d, e, f, g, dot);
      @(posedge clock) leddisp(a, b, c, d, e, f, g, dot);
      @(posedge clock) leddisp(a, b, c, d, e, f, g, dot);
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        reset_N <= 1;
        sdata   <= 0;    // A
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;    // B
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;    // C
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;    // D
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;    // E
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;    // F
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 0;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;    // G
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        sdata   <= 1;
      @(negedge clock) leddisp(a, b, c, d, e, f, g, dot);
        $finish;
     end

endmodule
